# -*- coding: utf-8 -*-
"""
Created on Wed Mar 25 18:31:01 2015

@author: Geert
"""

import sys
sys.path.append(r"/mnt/resfilsp10/pathology/Userdata/geert/Code")
from deeplearning.classification.wsi_classifier import WSIImageClassifier
import numpy as np

def classify_slide(slide, scales, model, out_pth, mask=None,
                   out_scale=None, patch_size=256):
    if out_scale is None:
        out_scale = len(scales)-1
    def softmax_tile(tile, row, col):
      e_x = np.exp(tile - tile.max(axis=0, keepdims=True))
      return e_x / e_x.sum(axis=0, keepdims=True)

    img_cla = WSIImageClassifier()
    img_cla.set_model(model)
    img_cla.set_input(slide, mask)
    img_cla.set_mode("fully_convolutional")
    img_cla.set_model_patch_size([3,patch_size,patch_size])
    img_cla.set_soft(True)
    img_cla.set_tile_size(512)
    img_cla.set_scales(scales)
    img_cla.set_output_scale(out_scale)
    img_cla.set_quantize(True)
    img_cla.set_quantize_min_and_max(0., 1.)
    img_cla.set_output_class(1)
    img_cla.set_postprocess_function(softmax_tile)
    img_cla.set_result_file_path(out_pth)
    img_cla.process()