# -*- coding: utf-8 -*-
"""
Created on Fri Sep 04 18:28:08 2015

@author: Geert
"""
import os
import sys
sys.path.append(r"D:\Code\pathology\install\bin")
import joblib
import numpy as np
import multiresolutionimageinterface as mir
from deeplearning.classification.wsi_classifier import WSIImageClassifier
import lasagne.layers as L

model = joblib.load(r"D:\Experiment\TMIDeepLearning\Networks\SingleScaleInfiniteTrainSet2_5xBatchNorm0.01LR\Model_At_Epoch_034.pkl")['model']
#ls = L.get_all_layers(model)
#model = ls[-3]

fl_pth = r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\10X (Converted)"
msk_pth = r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\10X (Converted)\TissueMasks"
out_pth = r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\10X (Converted)\LikelihoodMaps"
fls = sorted([x for x in os.listdir(fl_pth) if x.endswith(".svs")])
msk_fls = sorted(os.listdir(msk_pth))

img_cla = WSIImageClassifier()
img_cla.set_model(model)
img_cla.set_mode("fully_convolutional")
img_cla.set_model_patch_size([3,256,256])
img_cla.set_soft(True)
img_cla.set_tile_size(512)

r = mir.MultiResolutionImageReader()

def softmax_tile(tile, row, col):
  e_x = np.exp(tile - tile.max(axis=0, keepdims=True))
  return e_x / e_x.sum(axis=0, keepdims=True)

for f, m in zip(fls, msk_fls):
    out_file = os.path.join(out_pth, f[:-4] + ".tif")
    if not os.path.isfile(out_file):
      im = r.open(os.path.join(fl_pth, f))
      im_msk = r.open(os.path.join(msk_pth, m))
      img_cla.set_input(im, im_msk)
      img_cla.set_postprocess_function(softmax_tile)
      img_cla.set_result_file_path(out_file)
      img_cla.set_scales([im.getLevelDownsample(2)])
      img_cla.process()
