# -*- coding: utf-8 -*-
"""
Created on Wed Mar 25 18:31:01 2015

@author: Geert
"""
import os
import joblib
import sys
sys.path.append(r"/mnt/resfilsp10/pathology/Userdata/geert/Code")
from deeplearning.classification.wsi_classifier import WSIImageClassifier
import multiresolutionimageinterface as mir
import numpy as np
model = joblib.load(r"/mnt/resfilsp10/pathology/Userdata/geert/Experiments/model_multires_multiloss/Model_At_Epoch_0012.pkl")['model'][-1]
#model = joblib.load(r"/mnt/resfilsp10/pathology/Userdata/geert/Experiments/TMIDeepLearning/Networks/MultiScaleInfiniteTrainSet5xBatchNorm0.01LR/Model_At_Epoch_029.pkl")['model']

fl_pth = r"/mnt/SSD/geert_experiment/20x_converted"
msk_pth = r"/mnt/SSD/geert_experiment/20x_converted/LabelMasks"
out_pth = r"/mnt/resfilsp10/pathology/Userdata/geert/Experiments/TMIDeepLearning/Data/Prostatectomy/Nijmegen/20X_converted/LikelihoodMaps_multi_rein"
fls = os.listdir(msk_pth)

def softmax_tile(tile, row, col):
  e_x = np.exp(tile - tile.max(axis=0, keepdims=True))
  return e_x / e_x.sum(axis=0, keepdims=True)

img_cla = WSIImageClassifier()
img_cla.set_model(model)
img_cla.set_mode("fully_convolutional")
img_cla.set_model_patch_size([3,256,256])
img_cla.set_soft(True)
img_cla.set_tile_size(512)
img_cla.set_scales([2., 4., 8.])
img_cla.set_output_scale(2)
img_cla.set_quantize(True)
img_cla.set_output_class(1)
img_cla.set_postprocess_function(softmax_tile)

r = mir.MultiResolutionImageReader()
for f in fls[-1:]:
    f = r'T12-00516-7_01_APERIO.svs'
    out_file = os.path.join(out_pth, f)
    if not os.path.isfile(out_file):    
        print "Writing " + out_file        
        im_path = os.path.join(fl_pth, f[:-4] + ".svs")
        im = r.open(im_path)
        im_mask = r.open(os.path.join(msk_pth, f))
        img_cla.set_input(im)
        img_cla.set_result_file_path(out_file)
        img_cla.process()
