# -*- coding: utf-8 -*-
"""
Created on Wed Mar 25 18:31:01 2015

@author: Geert
"""

import os
import csv
import numpy as np

test_folder = r"Z:\pathology\Userdata\geert\Experiments\TMIDeepLearning\Results\210816\LikelihoodMaps_temp\SimpleNetwork_5x"

def get_best_epoch(model_folder, stat_type="mean"):
    epoch_folders = os.listdir(model_folder)
    threshold_keys = ['Threshold (1/8)', 'Threshold (2/8)', 'Threshold (4/8)',
                      'Threshold (6/8)','Threshold (7/8)']
    epoch_data = np.empty((23, len(threshold_keys)))
    dices = []
    dice_stds = []
    thresholds = []
    for epoch_folder in epoch_folders:
        current_epoch_result_path = os.path.join(model_folder, epoch_folder,
                                                 "dices.csv")
        if os.path.isfile(current_epoch_result_path):
            with open(current_epoch_result_path, 'r') as fl:
                csv_reader = csv.DictReader(fl)
                for i, row in enumerate(csv_reader):
                    epoch_data[i] = [float(row[key]) for key in threshold_keys]
            if stat_type == "mean":            
                epoch_means = np.mean(epoch_data, axis=0)
            else:
                epoch_means = np.median(epoch_data, axis=0)
            epoch_stds = np.std(epoch_data, axis=0)
            epoch_max = np.max(epoch_means)
            epoch_max_loc = np.argmax(epoch_means)
            epoch_max_std = epoch_stds[epoch_max_loc]
            dices.append(epoch_max)
            dice_stds.append(epoch_max_std)
            thresholds.append(epoch_max_loc)
    return dices, dice_stds, thresholds
        

dices, dice_tds, thresholds = get_best_epoch(test_folder, "median")