# -*- coding: utf-8 -*-
"""
Created on Tue Aug 09 19:39:50 2016

@author: Geert
"""

import multiresolutionimageinterface as mir
import numpy as np

def merge_tissue_and_annotation_mask(tis_im, ann_im, out_pth):
    dims = tis_im.getDimensions()
    w = mir.MultiResolutionImageWriter()
    w.openFile(out_pth)
    w.setTileSize(512)
    w.setCompression(mir.LZW)
    w.setDataType(mir.UChar)
    w.setColorType(mir.Monochrome)
    w.setInterpolation(mir.NearestNeighbor)
    w.writeImageInformation(dims[0], dims[1])    
    for y in xrange(0, dims[1], 512):
        print str(y) + "/" + str(dims[1])
        for x in xrange(0, dims[0], 512):
            t_p = np.squeeze(tis_im.getUCharPatch(x,y,512,512,0))
            a_p = np.squeeze(ann_im.getUCharPatch(x,y,512,512,0))
            l_p = (t_p * a_p) + t_p
            w.writeBaseImagePart(l_p.flatten().astype("ubyte"))
    w.finishImage()