# -*- coding: utf-8 -*-
"""
Created on Wed Sep 02 15:43:45 2015

@author: Geert
"""
import multiresolutionimageinterface as mir

import numpy as np


def calculate_dice_overlap(a1, a2):
    union = float(np.logical_and((a1 == True), (a2 == True)).sum())
    return 2*union/(a1.sum() + a2.sum())
    
def calculate_dice_overlap_for_wsi(mask_wsi, result_wsi, mask_level,
                                   result_level, mask_wsi_label=1,
                                   result_wsi_threshold=[128]):
    if mask_wsi.getLevelDimensions(mask_level) != result_wsi.getLevelDimensions(result_level):
        print "Dimensions not the same, cannot calculate Dice"
        print "Mask dimensions: " + str(mask_wsi.getLevelDimensions(mask_level))
        print "Result dimensions: " + str(result_wsi.getLevelDimensions(result_level))
        return
    eval_dims = mask_wsi.getLevelDimensions(mask_level)
    mask_img = np.squeeze(mask_wsi.getUCharPatch(0,0,eval_dims[0],eval_dims[1], mask_level))
    if mask_wsi_label in mask_img:
        result_img = np.squeeze(result_wsi.getFloatPatch(0,0,eval_dims[0],eval_dims[1], result_level))
        result_img = (((result_img - result_img.min()) / (result_img.max() - result_img.min())) * 255).astype("ubyte")
        mask_img = np.equal(mask_img, mask_wsi_label)
        dices = []
        for threshold in result_wsi_threshold:
            thresholded_img = np.greater(result_img, threshold)
            dices.append(calculate_dice_overlap(mask_img, thresholded_img))
        return dices
    else:
        return -1