# -*- coding: utf-8 -*-
"""
Created on Tue Jul 07 16:02:52 2015

@author: Geert
"""
import joblib
import theano
import theano.tensor as T
import lasagne
import numpy as np
import os
import time

import sys
sys.path.append(r"D:\Code\deeplearning\scripts\package")
sys.setrecursionlimit(1000000)
from deeplearning.data_handling.batch_iterator import BatchIterator
from deeplearning.data_handling.wsi_batch_provider import WSIBatchProvider
from deeplearning.visualization.weights_visualizer import *

# Inialize data sources
if __name__ == '__main__':
    train_pids = ['T12-08567', 'T10-22502', 'T13-02843', 'T09-09724', 'T13-01944', 'T12-08118', 'T12-27902', 'T11-08604', 'T12-06219', 'T13-00895', 'T11-02525', 'T12-19414', 'T12-27783', 'T09-02094', 'T13-01664', 'T12-06834', 'T09-05378', 'T12-12985', 'T12-09791', 'T12-00566', 'T10-25688', 'T11-06445', 'T11-12682', 'T12-21259', 'T13-08204', 'T09-07360', 'T13-06980', 'T12-18279', 'T10-12092', 'T10-02242', 'T12-13583', 'T13-02770', 'T12-27843', 'T12-25317', 'T11-13944', 'T12-28453', 'T12-08188', 'T09-19803', 'T09-10540', 'T09-00718']
    valid_pids = ['T13-02181', 'T09-15935', 'T09-20205', 'T12-18345', 'T13-03292', 'T09-00547', 'T13-02228', 'T09-01162', 'T11-17901', 'T12-02344']
    test_pids = ['T10-11651', 'T09-06145', 'T13-06855', 'T12-04657', 'T12-13013', 'T09-02945', 'T10-01303', 'T09-18887', 'T09-16382', 'T12-25320', 'T10-23057', 'T11-09493', 'T11-22480', 'T12-28953', 'T11-05235', 'T09-13977', 'T10-21465', 'T11-24126', 'T12-13653', 'T12-00534', 'T10-16714', 'T09-14602', 'T10-21344', 'T11-11959', 'T11-00924', 'T12-05641', 'T12-09731', 'T09-00391', 'T11-04986', 'T13-05484']
    
    msk_fls10x = os.listdir(r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\10x (Converted)\LabelMasks")                  
    fls10x = [x for x in os.listdir(r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\10x (Converted)") if x[0:-4] + ".tif" in msk_fls10x]
    
    tra_fls_10x = [tra_fl for tra_fl in fls10x if tra_fl[:9] in train_pids]
    val_fls_10x = [val_fl for val_fl in fls10x if val_fl[:9] in valid_pids]
    tes_fls_10x = [tes_fl for tes_fl in fls10x if tes_fl[:9] in test_pids]
    
    msk_fld_10x = r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\10x (Converted)\LabelMasks"
    val_fls_10x = [os.path.join(r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\10x (Converted)", f) for f in val_fls_10x]
    val_bi_10x = BatchIterator(val_fls_10x, data_level=1, nr_classes=2, provider=WSIBatchProvider, balanced=True, msk_src=msk_fld_10x, masks_level=6)
    
    msk_fls20x = os.listdir(r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\20x (Converted)\LabelMasks")                  
    fls20x = [x for x in os.listdir(r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\20x (Converted)") if x[0:-4] + ".tif" in msk_fls20x]
    
    tra_fls_20x = [tra_fl for tra_fl in fls20x if tra_fl[:9] in train_pids]
    val_fls_20x = [val_fl for val_fl in fls20x if val_fl[:9] in valid_pids]
    tes_fls_20x = [tes_fl for tes_fl in fls20x if tes_fl[:9] in test_pids]
    
    msk_fld_20x = r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\20x (Converted)\LabelMasks"
    val_fls_20x = [os.path.join(r"D:\Experiment\TMIDeepLearning\Data\Prostatectomy\Nijmegen\20x (Converted)", f) for f in val_fls_20x]
    val_bi_20x = BatchIterator(val_fls_20x, data_level=2, nr_classes=2, provider=WSIBatchProvider, balanced=True, msk_src=msk_fld_20x, masks_level=7)
    
    static_model_pth   = r"D:\Experiment\TMIDeepLearning\Networks\SingleScaleStaticTrainSet"
    infinite_model_pth = r"D:\Experiment\TMIDeepLearning\Networks\SingleScaleInfiniteTrainSet"
    
    mdl_fls = os.listdir(infinite_model_pth)
    target_var = T.fmatrix('targets')
    
    val_bi_10x.start()
    time.sleep(5)
    val_bi_20x.start()
    total_acc_inf = []
    total_acc_stat = []
    for mdl_fl in mdl_fls:
        print mdl_fl
        sta_network = joblib.load(os.path.join(static_model_pth, mdl_fl))['model']
        ls = lasagne.layers.get_all_layers(sta_network)
        inp_sta = ls[0].input_var
        inf_network = joblib.load(os.path.join(infinite_model_pth, mdl_fl))['model']
        ls = lasagne.layers.get_all_layers(inf_network)
        inp_inf = ls[0].input_var    
        test_prediction_sta = T.nnet.softmax(T.flatten(lasagne.layers.get_output(sta_network, deterministic=True), 2))
        test_prediction_inf = T.nnet.softmax(T.flatten(lasagne.layers.get_output(inf_network, deterministic=True), 2))
        test_loss_sta = lasagne.objectives.categorical_crossentropy(T.clip(test_prediction_sta, 0.0001, 0.9999),
                                                                target_var).mean()
        test_loss_inf = lasagne.objectives.categorical_crossentropy(T.clip(test_prediction_inf, 0.0001, 0.9999),
                                                                target_var).mean()
        
        test_acc_sta = T.mean(T.eq(T.argmax(test_prediction_sta, axis=1), T.argmax(target_var, axis=1)),
                          dtype=theano.config.floatX)
        test_acc_inf = T.mean(T.eq(T.argmax(test_prediction_inf, axis=1), T.argmax(target_var, axis=1)),
                          dtype=theano.config.floatX)
        val_fn_sta = theano.function([inp_sta, target_var], [test_acc_sta])
        val_fn_inf = theano.function([inp_inf, target_var], [test_acc_inf])
        acc_inf = []
        acc_stat = []
        for i in range(100):
            b = val_bi_20x.getBatch()
            acc_stat.append(val_fn_sta((b[0] / 255.).astype("float32"), b[1])[0])
            acc_inf.append(val_fn_inf((b[0] / 255.).astype("float32"), b[1])[0])
            b = val_bi_10x.getBatch()
            acc_stat.append(val_fn_sta((b[0] / 255.).astype("float32"), b[1])[0])
            acc_inf.append(val_fn_inf((b[0] / 255.).astype("float32"), b[1])[0])
        total_acc_stat.append(acc_stat)
        total_acc_inf.append(acc_inf)
        
