import lasagne
from lasagne.layers import dropout
from lasagne.layers.normalization import batch_norm

def cnn(input_var=None, dropout_p=0.0):
    network = batch_norm(lasagne.layers.InputLayer(shape=(None, 3, None, None),
                                        input_var=input_var[0]))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=24, filter_size=(5, 5),
              nonlinearity=lasagne.nonlinearities.rectify,
              W=lasagne.init.GlorotUniform()))
    network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)                      
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=48, filter_size=(5, 5),
              nonlinearity=lasagne.nonlinearities.rectify,
              W=lasagne.init.GlorotUniform()))
    network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)              
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=512, filter_size=(29, 29),
              nonlinearity=lasagne.nonlinearities.rectify,
              W=lasagne.init.GlorotUniform()))
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)              
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=2, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.identity,
              W=lasagne.init.GlorotUniform()))
    return network