import lasagne
from lasagne.layers.normalization import batch_norm
from lasagne.layers import dropout

def cnn(input_var=None, dropout_p=0.0, in_ptch_size=128):
    
    network = batch_norm(lasagne.layers.InputLayer(shape=(None, 3, None, None),
                                        input_var=input_var[0]))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=32, filter_size=(3, 3),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=32, filter_size=(3, 3),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=64, filter_size=(3, 3),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=64, filter_size=(3, 3),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=128, filter_size=(3, 3),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=128, filter_size=(3, 3),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network, num_filters=256, filter_size=(3, 3),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
    out_shape = lasagne.layers.get_output_shape(network, (1,3, in_ptch_size, in_ptch_size))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network,
              num_filters=512, filter_size=(out_shape[-2], out_shape[-1]),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)                    
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network,
              num_filters=256, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)                    
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network,
              num_filters=2, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.identity,
              W=lasagne.init.GlorotUniform()))
    return network  