import lasagne
from lasagne.layers.normalization import batch_norm
from lasagne.layers import dropout
import lasagne.layers as L
import joblib

def cnn(input_vars, dropout_p=0.0, in_ptch_size=128):
    scale_layers = []
    mdl_dct = joblib.load(r"/mnt/resfilsp10/pathology/Userdata/geert/experiments/TMIDeepLearning/Results/model_10x-complex-256/Model_At_Epoch_0081.pkl")
    params_s1 = L.get_all_param_values(mdl_dct['model'])
    mdl_dct = joblib.load(r"/mnt/resfilsp10/pathology/Userdata/geert/experiments/TMIDeepLearning/Results/model_0-6125x-complex-256/Model_At_Epoch_0467.pkl")
    params_s2 = L.get_all_param_values(mdl_dct['model'])
    params = [params_s1, params_s2]    
    for scale_nr, iv in enumerate(input_vars):
        network = batch_norm(lasagne.layers.InputLayer(shape=(None, 3, None, None),
                                            input_var=iv))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=32, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=32, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=64, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=64, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=128, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=128, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=256, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))  
        scale_layers.append(network)        
        out_shape = lasagne.layers.get_output_shape(network, (1,3, in_ptch_size, in_ptch_size))
        all_params = L.get_all_params(network)
        for param_i, param in enumerate(all_params):
            param.set_value(params[scale_nr][param_i])
        for layer in L.get_all_layers(network):
            param_dict = layer.params
            for param in param_dict.keys():
                if "trainable" in param_dict[param]:
                    param_dict[param].remove("trainable")
    network = lasagne.layers.ConcatLayer(scale_layers)
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network,
              num_filters=1024, filter_size=(out_shape[-2], out_shape[-1]),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)              
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network,
              num_filters=256, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)              
    network = lasagne.layers.Conv2DLayer(
              network,
              num_filters=2, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.identity,
              W=lasagne.init.GlorotUniform())
    return network