import lasagne
from lasagne.layers.normalization import batch_norm

def cnn(input_vars=[]):
    scale_layers = []
    loss_layers = []
    for iv in input_vars:
        network = lasagne.layers.InputLayer(shape=(None, 3, None, None),
                                            input_var=iv)      
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=32, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=32, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=64, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=64, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=128, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=128, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network, num_filters=256, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))  
        scale_layers.append(network)        
        network = batch_norm(lasagne.layers.Conv2DLayer(
                  network,
                  num_filters=512, filter_size=(12, 12),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()))        
        network = lasagne.layers.Conv2DLayer(
                  network,
                  num_filters=2, filter_size=(1, 1),
                  nonlinearity=lasagne.nonlinearities.leaky_rectify,
                  W=lasagne.init.GlorotUniform()) 
        loss_layers.append(network)
    network = lasagne.layers.ConcatLayer(scale_layers)
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network,
              num_filters=512, filter_size=(12, 12),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = batch_norm(lasagne.layers.Conv2DLayer(
              network,
              num_filters=256, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform()))
    network = lasagne.layers.Conv2DLayer(
              network,
              num_filters=2, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.leaky_rectify,
              W=lasagne.init.GlorotUniform())
    loss_layers.append(network)
    return loss_layers