import lasagne
import joblib
from lasagne import layers as L
from lasagne.layers.normalization import batch_norm
from lasagne.layers import dropout

def cnn(input_vars, dropout_p=0.0):
    mdl_dct = joblib.load(r"/mnt/resfilsp10/pathology/Userdata/geert/Experiments/TMIDeepLearning/Results/model_10x/Model_At_Epoch_0109.pkl")
    params_s1 = L.get_all_param_values(mdl_dct['model'])
    mdl_dct = joblib.load(r"/mnt/resfilsp10/pathology/Userdata/geert/Experiments/TMIDeepLearning/Results/model_1-25x/Model_At_Epoch_0128.pkl")
    params_s2 = L.get_all_param_values(mdl_dct['model'])
    params = [params_s1, params_s2]
    scale_layers = []
    nr_filters = 24
    for scale_nr, iv in enumerate(input_vars):
        network = lasagne.layers.InputLayer(shape=(None, 3, None, None),
                                            input_var=iv)      
        network = lasagne.layers.Conv2DLayer(
                  network, num_filters=nr_filters, filter_size=(5, 5),
                  nonlinearity=lasagne.nonlinearities.rectify,
                  W=params[scale_nr][0], b=params[scale_nr][1])
        network.params[network.W].remove("trainable")
        network.params[network.b].remove("trainable")
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = lasagne.layers.Conv2DLayer(
                  network, num_filters=2*nr_filters, filter_size=(5, 5),
                  nonlinearity=lasagne.nonlinearities.rectify,
                  W=params[scale_nr][2], b=params[scale_nr][3])
        network.params[network.W].remove("trainable")
        network.params[network.b].remove("trainable")                  
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = lasagne.layers.Conv2DLayer(
                  network, num_filters=4*nr_filters, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.rectify,
                  W=params[scale_nr][4], b=params[scale_nr][5])
        network.params[network.W].remove("trainable")
        network.params[network.b].remove("trainable")                  
        network = lasagne.layers.MaxPool2DLayer(network, pool_size=(2, 2))
        network = lasagne.layers.Conv2DLayer(
                  network, num_filters=4*nr_filters, filter_size=(3, 3),
                  nonlinearity=lasagne.nonlinearities.rectify,
                  W=params[scale_nr][6], b=params[scale_nr][7])
        network.params[network.W].remove("trainable")
        network.params[network.b].remove("trainable")                  
        network = lasagne.layers.Conv2DLayer(
                  network,
                  num_filters=1024, filter_size=(11, 11),
                  nonlinearity=lasagne.nonlinearities.rectify,
                  W=params[scale_nr][8], b=params[scale_nr][9])                 
        network.params[network.W].remove("trainable")
        network.params[network.b].remove("trainable")                  
        scale_layers.append(network)
    network = lasagne.layers.ConcatLayer(scale_layers)
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)
    network = lasagne.layers.Conv2DLayer(
              network,
              num_filters=512, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.rectify,
              W=lasagne.init.GlorotUniform())
    if dropout_p > 0.:
        network = dropout(network, p=dropout_p)              
    network = lasagne.layers.Conv2DLayer(
              network,
              num_filters=2, filter_size=(1, 1),
              nonlinearity=lasagne.nonlinearities.identity,
              W=lasagne.init.GlorotUniform())
    return network