# -*- coding: utf-8 -*-
"""
Created on Wed Aug 10 11:32:14 2016

@author: Geert
"""

import multiresolutionimageinterface as mir
import os
import numpy as np
from PIL import Image

def generate_screenshots(org_pth, overlays_pths, out_fldr, img_size=10000):
    base_name = os.path.splitext(os.path.split(org_pth)[1])[0]    
    out_file_pth = os.path.join(out_fldr, base_name + ".png")
    if not os.path.exists(out_file_pth):
        reader = mir.MultiResolutionImageReader()
        org_img = reader.open(org_pth)
        overlays = [reader.open(pth) for pth in overlays_pths]
        lut = np.array([[0,0,0,0], [0,255,0,51], [255,0,0,51], [0,0,255,51]], dtype="ubyte")
        levels = org_img.getNumberOfLevels()
        selected_level = 5
        for level in xrange(levels):
            dims = org_img.getLevelDimensions(level)
            if dims[0]  < img_size and dims[1] < img_size:
                selected_level = level
                selected_dims = dims
                break
        base_patch = org_img.getUCharPatch(0, 0, selected_dims[0], selected_dims[1], selected_level)
        overlay_patch = np.squeeze(overlays[0].getUCharPatch(0, 0, selected_dims[0], selected_dims[1], selected_level))
        if len(overlays) > 1:
            for label, overlay in enumerate(overlays):
                overlay_patch = np.maximum(overlay_patch, (label+2) * np.squeeze(overlay.getUCharPatch(0, 0, selected_dims[0], selected_dims[1], selected_level)))
        ov_lut = lut[overlay_patch]
        base_img = Image.fromarray(base_patch).convert("RGBA")
        ov_img = Image.fromarray(ov_lut)
        comp_img = Image.alpha_composite(base_img, ov_img)
        comp_img.save(out_file_pth)